// Unit BugTracker
(**************************************************

- Enthlt: TBugTracker

**************************************************)

unit F2D_BugTracker;

interface

uses
  // Bentigte Units
  Windows, SysUtils, Dialogs;

type
  // BugTracker
  TBugTracker = class
    constructor Create(pWriteLogFile: boolean);
    destructor Destroy; override;
    procedure Free;
  private
    // LogFile, liegt im Programmverzeichnis und enthlt
    // Informationen ber (nicht) geladene Texturen und Sounds

    FLogFile: TextFile;
    FWriteLogFile: boolean;
  public
    property WriteLogFile: boolean read FWriteLogFile;
    // Schreibt einen String (WriteLn)
    procedure Write(pstr: String);
  end;

implementation

constructor TBugTracker.Create(pWriteLogFile: boolean);
var
  FilePath: String;
begin
  inherited Create;
  FWriteLogFile := pWriteLogFile;
  if not pWriteLogFile then
    exit;
  // Dateipfad
  FilePath := ExtractFilePath(ParamStr(0)) + 'log.txt';

  // Datei zuweisen
  AssignFile(FLogFile, FilePath);

  // Falls Datei existiert -> ans Ende springen, sonst neu erstellen
  if FileExists(FilePath) then
    Append(FLogFile)
  else
    ReWrite(FLogFile);

  // AnfangsText schreiben
  WriteLn(FLogFile, '---//--Engine Loaded--\\---');

  // Datum und Uhrzeit schreiben
  WriteLn(FLogFile, '----' + FormatDateTime('dd.mm.yyyy, hh:nn:ss', Now) + '----');
  WriteLn(FLogFile, '');
end;

destructor TBugTracker.Destroy;
begin
  if FWriteLogFile then
  begin
    // EndText schreiben
    WriteLn(FLogFile, '---\\--Engine Closed--//---');
    WriteLn(FLogFile, '');
    CloseFile(FLogFile);
  end;
  inherited Destroy;
end;

procedure TBugTracker.Free;
begin
  if Self <> nil then
    Destroy;
end;

procedure TBugTracker.Write(pstr: String);
begin
  if not FWriteLogFile then
    exit;
  // LogFile schreiben
  WriteLn(FLogFile, pstr);
  Flush(flogfile);
end;

end.
