// Unit Colors
(**************************************************

- Enthlt: TColorRGB

  ByteToSingle
  ColorToColorRGB
  RGBf
  RGBAf

**************************************************)

unit F2D_Colors;

interface

uses windows, graphics, dglOpenGL;

type
  // Speichert RGB Werte
  TColorRGB = record
    R, G, B: single;
  end;

  // Wandelt ein Byte in sein single Equivalent um (aus 255 wird 1)
  function ByteToSingle(aByte: Byte): Single;
  // Wandelt eine TColor in Ein TColorRGB um
  function ColorToColorRGB(Color: TColor): TColorRGB;
  // Entspricht Color3f nur mit einer TColor
  procedure RGBf(Color: TColor);
  // Entspricht Color4f nur mit einer TColor und einem Byte Alpha Wert 0 - 255
  procedure RGBAf(Color: TColor; Alpha: Integer);

implementation

function ByteToSingle(aByte: Byte): Single;
begin
  // Byte in Single umwandeln
  Result := aByte / 255;
end;

function ColorToColorRGB(Color: TColor): TColorRGB;
begin
  // Einzelne Werte mit hilfe von ByteToSingle Umwandeln
  Result.R := ByteToSingle(GetRvalue(ColorToRgb(Color)));
  Result.G := ByteToSingle(GetGvalue(ColorToRgb(Color)));
  Result.B := ByteToSingle(GetBvalue(ColorToRgb(Color)));
end;

procedure RGBf(Color: TColor);
var
  aColorRGB: TColorRGB;
begin
  // Color3f
  aColorRGB := ColorToColorRGB(Color);
  glColor3f(aColorRGB.R, aColorRGB.G, aColorRGB.B);
end;

procedure RGBAf(Color: TColor; Alpha: Integer);
var
  aColorRGB: TColorRGB;
begin
  // Color4f
  aColorRGB := ColorToColorRGB(Color);
  glColor4f(aColorRGB.R, aColorRGB.G, aColorRGB.B, ByteToSingle(Alpha));
end;

end. 
