// Unit Math
(**************************************************

- Enthlt: Mathematische berechnungen

**************************************************)

unit F2D_Math;

interface

uses
  F2D_Vectors,
  Windows,
  math;

//Findet den normal Vektor zu einem Winkel
function angle_to_v2d(angle: single): TVector2D;
//Findet den Winkel zu einem normalen Vektor
function v2d_to_angle(vec: TVector2D): single;

function TranslateRect(R: TRect; dx, dy: integer): TRect;
function RectCenter(R: TRect): TVector2D;

implementation

uses Types;

function angle_to_v2d(angle: single): TVector2D;
begin
  result := to_v2d(cos(degtorad(angle)), sin(degtorad(angle)));
end;

function v2d_to_angle(vec: TVector2D): single;
begin
  if vec.X = 0 then begin
    if vec.Y > 0 then
      result := 0.5 * pi
    else
      result := 1.5 * pi
  end
  else {X <> 0}
    if vec.X > 0 then
      result := Arctan(vec.Y / vec.X)
    else
      result := Arctan(vec.Y / vec.X) + pi;
  Result:= RadToDeg(Result);
end;

function TranslateRect(R: TRect; dx, dy: integer): TRect;
begin
  Result.Left := R.Left + dx;
  Result.Right := R.Right + dx;
  Result.Top := R.Top + dy;
  Result.Bottom := R.Bottom + dy;
end;

function RectCenter(R: TRect): TVector2D;
begin
  Result.x := (R.Left + R.Right) / 2;
  Result.y := (R.Top + R.Bottom) / 2;
end;

end.

