// Unit StateMachine
(**************************************************

- Enthlt: TStateMachine

**************************************************)

unit F2D_StateMachine;

interface

uses
  inifiles;

type
  TStateMachine = class
    constructor Create;
    destructor Destroy; override;
    procedure Free;
  private
    States: THashedStringlist;
    FIndex: integer;
  public
    procedure AddState(pStateName: string);
    procedure RemoveState(pStateName: string);
    procedure SetState(pStateName: string);
    function GetState: string;
  end;

implementation

constructor TStateMachine.Create;
begin
  inherited Create;
  States := THashedStringList.Create;
  FIndex := -1;
end;

destructor TStateMachine.Destroy;
begin
  States.Free;
  inherited Destroy;
end;

procedure TStateMachine.Free;
begin
  if Self <> nil then
    Destroy;
end;

procedure TStateMachine.AddState(pStateName: string);
begin
  if (States.IndexOf(pStateName) = -1) then
    States.Add(pStateName);
end;

procedure TStateMachine.RemoveState(pStateName: string);
var
  aIndex: integer;
begin
  aIndex := States.IndexOf(pStateName);
  if (aIndex > -1) then
  begin
    States.Delete(States.IndexOf(pStateName));
    if FIndex = aIndex then
      FIndex := -1;
  end;
end;

procedure TStateMachine.SetState(pStateName: string);
begin
  Findex := States.IndexOf(pStateName);
end;

function TStateMachine.GetState: string;
begin
  if FIndex > 0 then
    result := States.Strings[FIndex];
end;

end.
