// Unit Vectors
(**************************************************

- Enthlt: TVector2D

**************************************************)

unit F2D_Vectors;

interface

type
  // 2D Vektor
  TVector2D = record
    X, Y: Single;
  end;

  // Zwei Singles in einen TVector2D umwandeln
  function To_V2D(X, Y: Single): TVector2D;
  // Zwei Vektoren addieren
  function V2D_Add(V1, V2: TVector2D): TVector2D;
  // Einen Vektor von einem anderen subtrahieren
  function V2D_Sub(V1, V2: TVector2D): TVector2D;
  // Einen Vektor skalieren
  function V2D_Scale(V: TVector2D; Scalar: Single): TVector2D;
  // Ermittelt die Lnge eines Vektors
  function V2D_Length(V: TVector2D): Single;
  // Normalisiert einen Vektor (sodass v2d_length = 1
  function V2D_Normalize(V: TVector2D): TVector2D;
  // Ermittelt ds Skalarprodukt
  function V2D_DotProduct(V1, V2: TVector2D): Single;

implementation

function To_V2D(X, Y: Single): TVector2D;
begin
  Result.X := X;
  Result.Y := Y;
end;

function V2D_Add(V1, V2: TVector2D): TVector2D;
begin
  Result.X := V1.X + V2.X;
  Result.Y := V1.Y + V2.Y;
end;

function V2D_Sub(V1, V2: TVector2D): TVector2D;
begin
  Result.X := V1.X - V2.X;
  Result.Y := V1.Y - V2.Y;
end;

function V2D_Scale(V: TVector2D; Scalar: Single): TVector2D;
begin
  Result.X := V.X * Scalar;
  Result.Y := V.Y * Scalar;
end;

function V2D_Length(V: TVector2D): Single;
begin
  Result := sqrt(V.X * V.X + V.Y * V.Y);
end;

function V2D_Normalize(V: TVector2D): TVector2D;
var
  L: Single;
begin
  L := V2D_Length(V);

  if L = 0 then
    L := 1;

  Result := V2D_Scale(V, 1 / L);
end;

function V2D_DotProduct(V1, V2: TVector2D): Single;
begin
  Result := V1.X * V2.X + V1.Y * V2.Y;
end;

end.
